Package: distinct
Type: Package
Title: distinct: a method for differential analyses via hierarchical
        permutation tests
Version: 1.22.0
Author: Simone Tiberi [aut, cre].
Maintainer: Simone Tiberi <simone.tiberi@uzh.ch>
Description: distinct is a statistical method to perform differential testing between two or more groups of distributions; 
  differential testing is performed via hierarchical non-parametric permutation tests on the cumulative distribution functions (cdfs) of each sample.
  While most methods for differential expression target differences in the mean abundance between conditions, 
  distinct, by comparing full cdfs, identifies, both, differential patterns involving changes in the mean,
  as well as more subtle variations that do not involve the mean (e.g., unimodal vs. bi-modal distributions with the same mean).
  distinct is a general and flexible tool: due to its fully non-parametric nature, 
  which makes no assumptions on how the data was generated, it can be applied to a variety of datasets.
  It is particularly suitable to perform differential state analyses on single cell data (i.e., differential analyses within sub-populations of cells), 
  such as single cell RNA sequencing (scRNA-seq) and high-dimensional flow or mass cytometry (HDCyto) data.
  To use distinct one needs data from two or more groups of samples (i.e., experimental conditions), with at least 2 samples (i.e., biological replicates) per group.
biocViews: Genetics, RNASeq, Sequencing, DifferentialExpression,
        GeneExpression, MultipleComparison, Software, Transcription,
        StatisticalMethod, Visualization, SingleCell, FlowCytometry,
        GeneTarget
License: GPL (>= 3)
Depends: R (>= 4.3)
Imports: Rcpp, stats, SummarizedExperiment, SingleCellExperiment,
        methods, Matrix, foreach, parallel, doParallel, doRNG, ggplot2,
        limma, scater
Suggests: knitr, rmarkdown, testthat, UpSetR, BiocStyle
LinkingTo: Rcpp, RcppArmadillo
SystemRequirements: C++17
VignetteBuilder: knitr
RoxygenNote: 7.2.3
ByteCompile: true
URL: https://github.com/SimoneTiberi/distinct
BugReports: https://github.com/SimoneTiberi/distinct/issues
git_url: https://git.bioconductor.org/packages/distinct
git_branch: RELEASE_3_22
git_last_commit: 8dca3b7
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: yes
Packaged: 2025-10-30 03:42:07 UTC; biocbuild

# distinct: a method for differential analyses via hierarchical permutation tests

<img src="inst/extdata/distinct.png" width="200" align="right"/> 

`distinct` is a statistical method to perform differential testing between two or more groups of distributions; differential testing is performed via non-parametric permutation tests on the cumulative distribution functions (cdfs) of each sample.
`distinct` is a general and flexible tool: due to its fully non-parametric nature, which makes no assumptions on how the data was generated, it can be applied to a variety of datasets.
It is particularly suitable to perform differential state analyses on single cell data (i.e., differential analyses within sub-populations of cells), such as single cell RNA sequencing (scRNA-seq) and high-dimensional flow or mass cytometry (HDCyto) data.
The method also allows for nuisance covariates (such as batch effects).

> Simone Tiberi, Helena L Crowell, Pantelis Samartsidis, Lukas M Weber, and Mark D Robinson (2023).
>
> distinct: a novel approach to differential distribution analyses.
>
> The Annals of Applied Statistics.
> Available [here](https://www.e-publications.org/ims/submission/AOAS/user/submissionFile/52840?confirm=11abdc0f)

## Bioconductor installation 
`distinct` is available on [Bioconductor](https://bioconductor.org/packages/distinct) and can be installed with the command:
``` r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("distinct")
```

## Vignette
The vignette illustrating how to use the package can be accessed on 
[Bioconductor](https://bioconductor.org/packages/distinct)
or from R via:
``` r
vignette("distinct")
```
or
``` r
browseVignettes("distinct")
```

#' Filter significant results.
#'
#' \code{top_results} returns the significant results obtained via \code{\link{distinct_test}}.
#' 
#' @param res a \code{\linkS4class{data.frame}} with results as returned from \code{\link{distinct_test}}.
#' @param cluster a character indicating the cluster(s) whose results have to be returned. 
#' Results from all clusters are returned by default ("all").
#' @param significance numeric, results with adjusted p-value < significance will be returned.
#' @param global logical indicating whether to filter results according to p_adj.glb (when TRUE), or p_adj.loc (when FALSE).
#' @param up_down a character indicating whether to return: all results ("both" or "BOTH"), only up-regulated results ("up" or "UP") or down-regulated results ("down" or "DOWN").
#' In `res`, a FC > 1 (or log2FC > 0) indicates up-regulation of group1 (compared to group2); while a FC < 1 (or log2FC < 0) indicates down-regulation of group1 (compared to group2).
#' @param sort_by a character indicating how results should be sorted.
#' Results can be sorted by globally adjusted p-value ("p_adj.glb", default choice), locally adjusted p-value ("p_adj.loc"), raw p-value ("p_val") or (log2)fold-change ("FC" or "log2FC").
#' @return A \code{\linkS4class{data.frame}} object.
#' Columns `gene` and `cluster_id` contain the gene and cell-cluster name, while `p_val`, `p_adj.loc` and `p_adj.glb` report the raw p-values, locally and globally adjusted p-values, via Benjamini and Hochberg (BH) correction.
#' In locally adjusted p-values (`p_adj.loc`) BH correction is applied in each cluster separately, while in globally adjusted p-values (`p_adj.glb`) BH correction is performed to the results from all clusters.
#' @examples
#' # load pre-computed results (obtaines via `distinct_test`)
#' data("res", package = "distinct")
#' 
#' # Visualize significant results:
#' head(top_results(res))
#' 
#' # Visualize significant results from a specified cluster of cells:
#' top_results(res, cluster = "Dendritic cells")
#' 
#' # We can optionally add the fold change (FC) and log2-FC between groups:
#' # load the input data:
#' data("Kang_subset", package = "distinct")
#' 
#' res = log2_FC(res = res,
#'   x = Kang_subset, 
#'   name_assays_expression = "cpm",
#'   name_group = "stim",
#'   name_cluster = "cell")
#' 
#' # By default, results from 'top_results' are sorted by (globally) adjusted p-value;
#' # they can also be sorted by log2-FC:
#' top_results(res, cluster = "Dendritic cells", sort_by = "log2FC")
#' 
#' # Visualize significant UP-regulated genes only:
#' top_results(res, up_down = "UP",
#'   cluster = "Dendritic cells")
#' 
#' @author Simone Tiberi \email{simone.tiberi@uzh.ch}
#' 
#' @seealso \code{\link{distinct_test}}, \code{\link{log2_FC}}
#' 
#' @export
top_results = function(res, 
                       cluster = "all",
                       significance = 0.01,
                       global = TRUE,
                       up_down = "both",
                       sort_by = "p_adj.glb"){
  stopifnot(
    is.data.frame(res),
    is.character(cluster), length(cluster) > 0L,
    is.numeric(significance), length(significance) == 1L,
    is.logical(global), length(global) == 1L,
    is.character(up_down), length(up_down) == 1L,
    is.character(sort_by), length(sort_by) == 1L
  )
  
  if( !(up_down %in% c("both", "BOTH", "up", "UP", "down", "DOWN")) ){
    message("'up_down' should be one of: 'both', 'BOTH', 'up', 'UP', 'down', 'DOWN'")
    return(NULL)
  }
  
  if( !(sort_by %in% c("p_adj.glb", "p_adj.loc", "p_val", "FC", "log2FC")) ){
    message("'sort_by' should be one of: 'p_adj.glb', 'p_adj.loc', 'p_val', 'FC', 'log2FC'")
    return(NULL)
  }
  
  if(global){
    sel_rows = res$p_adj.glb < significance
  }else{
    sel_rows = res$p_adj.loc < significance
  }
  
  # if cluster is not "all", then I must filter clusters too:
  if(cluster != "all"){
    # check that "cluster" is among cluster names in cluster_id slot:
    if( !any(cluster %in% res$cluster_id) ){
      message("'cluster' not found in 'res$cluster_id' make sure cluster is typed correctly.")
      return(NULL)
    }
    
    sel_cluster = res$cluster %in% cluster
    sel_rows = sel_rows & sel_cluster
  }
  
  # filter by gene (and cluster)
  res = res[sel_rows,]
  
  # filter by UP-down regulation if required:
  if(up_down %in% c("up", "UP", "down", "DOWN")){
    sel_log2FC = grep("log2FC", colnames(res))
    if(length(sel_log2FC) == 0){
      message("To filter up- or down-regulated results, first compute 'FC' and 'log2FC' via 'log2_FC' function; otherwise avoid filtering and set up_down = 'both'.")
      return(NULL)
    }
    
    if(up_down %in% c("up", "UP")){ # filter UP-regulated results only:
      sel_genes = res[,sel_log2FC] >= 0
      res = res[ sel_genes, ]
    }else{
      sel_genes = res[,sel_log2FC] < 0
      res = res[ sel_genes, ]
    }
  }
  
  # order results:
  if( sort_by == "p_adj.glb"){
    res = res[ order(res$p_adj.glb), ]
  }
  if( sort_by == "p_adj.loc"){
    res = res[ order(res$p_adj.loc), ]
  }
  if( sort_by == "p_val"){
    res = res[ order(res$p_val), ]
  }
  
  if( sort_by %in% c("FC", "log2FC") ){
    sel_log2FC = grep("log2FC", colnames(res))
    if(length(sel_log2FC) == 0){
      message("To sort by FC or log2FC, first compute 'FC' and 'log2FC' via 'log2_FC' function; otherwise sort by (raw or adjusted) p-value.")
      return(NULL)
    }
    res = res[ order( abs(res[ ,sel_log2FC ]), decreasing = TRUE), ]
  }
  
  res
}

test_that("top_results() works faultlessly.", {
  # load pre-computed results (obtaines via `distinct_test`)
  data("res", package = "distinct")
  
  # Visualize significant results:
  top_1 = top_results(res)

  # Visualize significant results:
  top_2 = top_results(res, significance = 0.1)

  # Visualize significant results:
  top_3 = top_results(res, global = FALSE)
    
  # Visualize significant results from a specified cluster of cells:
  top_4 =  top_results(res, cluster = "Dendritic cells")
  
  expect_is(top_1, "data.frame")
  expect_is(top_2, "data.frame")
  expect_is(top_3, "data.frame")
  expect_is(top_4, "data.frame")
})

#' Test for differential state between two groups of samples, based on scRNA-seq data.
#'
#' \code{distinct_test} tests for differential state between two groups of samples.
#' 
#' @param x a \code{linkS4class{SummarizedExperiment}} or a \code{linkS4class{SingleCellExperiment}} object.
#' @param name_assays_expression a character ("logcounts" by default), 
#' indicating the name of the assays(x) element which stores the expression data (i.e., assays(x)$name_assays_expression).
#' We strongly encourage using normalized data, such as counts per million (CPM) or log2-CPM (e.g., 'logcounts' as created via \code{scater::logNormCounts}).
#' In case additional covariates are provided (e.g., batch effects), we highly recommend using log-normalized data, such as log2-CPM (e.g., 'logcounts' as created via \code{scater::logNormCounts}).
#' @param name_cluster a character ("cluster_id" by default), 
#' indicating the name of the colData(x) element which stores the cluster id of each cell (i.e., colData(x)$name_cluster).
#' @param name_sample a character ("sample_id" by default), 
#' indicating the name of the colData(x) element which stores the sample id of each cell (i.e., colData(x)$name_sample).
#' @param design a \code{\linkS4class{matrix}} or \code{\linkS4class{data.frame}} with the design matrix of the study (e.g., built via model.matrix(~batches), 
#' design must contain one row per sample, while columns include intercept, group and eventual covariates such as batches.
#' Row names of design must indicate the sample ids, and correspond to the names in colData(x)$name_sample.
#' @param column_to_test indicates the column(s) of the design one wants to test (do not include the intercept).
#' @param P_1 the number of permutations to use on all gene-cluster combinations.
#' @param P_2  the number of permutations to use, when a (raw) p-value is < 0.1 (500 by default).
#' @param P_3  the number of permutations to use, when a (raw) p-value is < 0.01 (2,000 by default).
#' @param P_4  the number of permutations to use, when a (raw) p-value is < 0.001 (10,000 by default).
#' In order to obtain a finer ranking for the most significant genes,
#' if computational resources are available, we encourage users to set P_4 = 20,000.
#' @param N_breaks the number of breaks at which to evaluate the comulative density function.
#' @param min_non_zero_cells the minimum number of non-zero cells (across all samples) in each cluster for a gene to be evaluated.
#' @param n_cores the number of cores to parallelize the tasks on (parallelization is at the cluster level: each cluster is parallelized on a thread).
#' @return A \code{\linkS4class{data.frame}} object.
#' Columns `gene` and `cluster_id` contain the gene and cell-cluster name, while `p_val`, `p_adj.loc` and `p_adj.glb` report the raw p-values, locally and globally adjusted p-values, via Benjamini and Hochberg (BH) correction.
#' In locally adjusted p-values (`p_adj.loc`) BH correction is applied in each cluster separately, while in globally adjusted p-values (`p_adj.glb`) BH correction is performed to the results from all clusters.
#' Column `filtered` indicates whether a gene-cluster result was filtered (if TRUE), or analyzed (if FALSE).
#' A gene-cluster combination is filtered when fewer than `min_non_zero_cells` non-zero cells are available.
#' Filtered results have raw and adjusted p-values equal to 1.
#' @examples
#' # load the input data:
#' data("Kang_subset", package = "distinct")
#' Kang_subset
#' 
#' # create the design of the study:
#' samples = Kang_subset@metadata$experiment_info$sample_id
#' group = Kang_subset@metadata$experiment_info$stim
#' design = model.matrix(~group)
#' # rownames of the design must indicate sample ids:
#' rownames(design) = samples
#' design
#' 
#' # Note that the sample names in `colData(x)$name_sample` have to be the same ones as those in `rownames(design)`.
#' rownames(design)
#' unique(SingleCellExperiment::colData(Kang_subset)$sample_id)
#' 
#' # In order to obtain a finer ranking for the most significant genes, if computational resources are available, we encourage users to increase P_4 (i.e., the number of permutations when a raw p-value is < 0.001) and set P_4 = 20,000 (by default P_4 = 10,000).
#' 
#' # The group we would like to test for is in the second column of the design, therefore we will specify: column_to_test = 2
#' 
#' set.seed(61217)
#' res = distinct_test(
#'   x = Kang_subset, 
#'   name_assays_expression = "logcounts",
#'   name_cluster = "cell",
#'   design = design,
#'   column_to_test = 2,
#'   min_non_zero_cells = 20,
#'   n_cores = 2)
#' 
#' # We can optionally add the fold change (FC) and log2-FC between groups:
#' res = log2_FC(res = res,
#'   x = Kang_subset, 
#'   name_assays_expression = "cpm",
#'   name_group = "stim",
#'   name_cluster = "cell")
#' 
#' # Visualize significant results:
#' head(top_results(res))
#' 
#' # Visualize significant results from a specified cluster of cells:
#' top_results(res, cluster = "Dendritic cells")
#' 
#' # By default, results from 'top_results' are sorted by (globally) adjusted p-value;
#' # they can also be sorted by log2-FC:
#' top_results(res, cluster = "Dendritic cells", sort_by = "log2FC")
#' 
#' # Visualize significant UP-regulated genes only:
#' top_results(res, up_down = "UP",
#'   cluster = "Dendritic cells")
#' 
#' # Plot density and cdf for gene 'ISG15' in cluster 'Dendritic cells'.
#' plot_densities(x = Kang_subset,
#'   gene = "ISG15",
#'   cluster = "Dendritic cells",
#'   name_assays_expression = "logcounts",
#'   name_cluster = "cell",
#'   name_sample = "sample_id",
#'   name_group = "stim")
#'  
#'  plot_cdfs(x = Kang_subset,
#'    gene = "ISG15",
#'    cluster = "Dendritic cells",
#'    name_assays_expression = "logcounts",
#'    name_cluster = "cell",
#'    name_sample = "sample_id",
#'    name_group = "stim")
#' 
#' @author Simone Tiberi \email{simone.tiberi@uzh.ch}
#' 
#' @seealso \code{\link{plot_cdfs}}, \code{\link{plot_densities}}, \code{\link{log2_FC}}, \code{\link{top_results}}
#' 
#' @export
distinct_test = function(x, 
                         name_assays_expression = "logcounts",
                         name_cluster = "cluster_id",
                         name_sample = "sample_id",
                         design, # design matrix
                         column_to_test = 2,
                         P_1 = 100, 
                         P_2 = 500, 
                         P_3 = 2000, 
                         P_4 = 10000, 
                         N_breaks = 25, 
                         min_non_zero_cells = 20,
                         n_cores = 1){
  stopifnot(
    ( is(x, "SummarizedExperiment") | is(x, "SingleCellExperiment") ),
    is.character(name_assays_expression), length(name_assays_expression) == 1L,
    is.character(name_cluster), length(name_cluster) == 1L,
    is.character(name_sample), length(name_sample) == 1L,
    is.matrix(design) | is.data.frame(design),
    is.numeric(column_to_test), length(column_to_test) > 0L,
    is.numeric(P_1), length(P_1) == 1L,
    is.numeric(P_2), length(P_2) == 1L,
    is.numeric(P_3), length(P_3) == 1L,
    is.numeric(P_4), length(P_4) == 1L,
    is.numeric(N_breaks), length(N_breaks) == 1L,
    is.numeric(min_non_zero_cells), length(min_non_zero_cells) == 1L,
    is.numeric(n_cores), length(n_cores) == 1L
  )
  
  # check P's are in a non-decreasing order:
  if( (P_1 > P_2) | (P_2 > P_3) | (P_3 > P_4) ){
    message("The number of permutations `P_x` must be in a non-decreasing order: P_1 <= P_2 <= P_3 <= P_4")
    return(NULL)
  }
  
  # check for NA's:
  if(any(is.na(design)) | any(is.null(design)) | any(is.nan(design))){
    message("'design' contains NA, NULL or NaN values")
    return(NULL)
  }
  
  if(!is.fullrank(design)){ # if the matrix is NOT full rank:
    message("'design' is not full rank")
    return(NULL)
  }
  
  # lower-bound for min_non_zero_cells:
  if(min_non_zero_cells < 0){
    message("'min_non_zero_cells' must be at least 0")
    return(NULL)
  }
  
  # count matrix:
  sel = which(names(assays(x)) == name_assays_expression)
  if( length(sel) == 0 ){
    message("'", name_assays_expression, "' not found in names(assays(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'", name_assays_expression, "' found multiple times in names(assays(x))")
    return(NULL)
  }
  counts = assays(x)[[sel]]
  
  if(any(is.na(counts)) | any(is.null(counts)) ){
    message("'assays(x)$", name_assays_expression,"' contains NA or NULL values")
    return(NULL)
    # OR: message("These values will be removed in differentiala anlyses")
    # To allow for NAs -> edit C++ scripts, by remove NAs for each gene (in gene loop), and editing indeces
  }
  # remove rows with 0 counts:
  if(nrow(counts) > 1.5){ # only if more than 1 gene (row): otherwise matrix is transformed into a vector
    counts = counts[ rowSums(counts > 0) > 0, ]
  }
  
  # check if counts are sparse matrix: if not, turn counts intro Sparce object:
  if(!is(counts, "dgCMatrix")){
    counts = Matrix(data=counts, 
                    sparse = TRUE)
  }
  
  # cluster ids:
  sel = which(names(colData(x)) == name_cluster)
  if( length(sel) == 0 ){
    message("'", name_cluster,"' not found in names(colData(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'", name_cluster,"' found multiple times in names(colData(x))")
    return(NULL)
  }
  cluster_ids = factor(colData(x)[[sel]])
  n_clusters = nlevels(cluster_ids)
  cluster_ids_num = as.numeric(cluster_ids)-1
  
  # sample ids:
  sel = which(names(colData(x)) == name_sample)
  if( length(sel) == 0 ){
    message("'", name_sample,"' not found in names(colData(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'", name_sample,"' found multiple times in names(colData(x))")
    return(NULL)
  }
  sample_ids = factor(colData(x)[[sel]])
  
  nas = is.na(sample_ids) | is.null(sample_ids) | is.nan(sample_ids) | is.na(cluster_ids) | is.null(cluster_ids) | is.nan(cluster_ids)
  if(any(nas)){
    message("NAs, NULL or NaN found in 'colData(x)$",name_sample,"' and/or 'colData(x)$",name_cluster,"': removing corresponding cells")
    sample_ids  = sample_ids[!nas]
    cluster_ids_num = cluster_ids_num[!nas]
    counts = counts[,!nas]
  }
  
  # check if ALL samples names from rownames(design) are present in sample_ids
  # maybe allow for samples to be present in sample_ids but not in rownames(design) ?
  if( ! all(rownames(design) %in% sample_ids)){
    message("All samples names in 'rownames(design)' must be present in 'colData(x)$",name_sample,"'")
    return(NULL)
  }
  if( ! all(sample_ids %in% rownames(design))){
    message("All samples names in 'colData(x)$",name_sample,"' must be present in 'rownames(design)'")
    return(NULL)
  }
  
  # sample ids:
  sample_ids = factor(sample_ids, levels = rownames(design)) # keep the order in design
  n_samples = nlevels(sample_ids)
  sample_ids_num = as.numeric(sample_ids)-1
  
  # group ids (1 per cell)
  if(ncol(design) < column_to_test){
    message("'column_to_test' cannot be bigger than 'ncol(design)'")
    return(NULL)
  }
  
  # extract group ids from experiment_info:
  group_ids_of_samples = apply(as.matrix(design[,column_to_test]), 1, paste, collapse = ".")
  group_ids_of_samples = as.numeric(factor(group_ids_of_samples))
  
  groups = unique(group_ids_of_samples)
  n_samples_per_group = vapply( groups, function(g) sum(group_ids_of_samples == g), FUN.VALUE = numeric(1) )
  # n_samples_per_group contains the samples of each group (e.g., 3 2)
  n_samples_per_group_per_sample = n_samples_per_group[match(group_ids_of_samples,groups)]
  # n_samples_per_group_per_sample contains the samples of each group that samples belong to, (e.g., 3 3 3 2 2) 
  
  n_groups = length(groups)
  
  message(paste0(n_groups, " groups of samples provided"))
  
  if(n_groups < 1.5){
    message("One group only detected; at least 2 groups are needed to perform differential testing between groups")
    return(NULL)
  }
  
  # remove columns to test from the design:
  design_covar = design[,-column_to_test]
  
  # check if design matrix, without covariates columns still has > 1 column (i.e., not only the intercept):
  cond_covariates = ncol(design) - length(column_to_test) > 1.5 
  if( cond_covariates ){ # 2-group WITH COVARIATES:
    message("Covariates detected")
  }
  
  message("Data loaded, starting differential testing")
  
  if(n_groups > 2.5){
    message("At most 2 groups should be provided.")
    message("To compare more than 2 groups, perform pairwise testing between pairs of groups.")
    return(NULL)
  }else{
    if( cond_covariates ){ # 2-group WITH COVARIATES:
      
      if(n_cores > 1){
        # call a R wrapper, that parallelizes Rcpp code from R:
        p_val = perm_test_parallel_covariates_R(P_1, # number of permutations
                                                P_2,
                                                P_3,
                                                P_4,
                                                N_breaks, # number of breaks at which to evaluate the cdf
                                                cluster_ids_num, # ids of clusters (cell-population) for every cell
                                                sample_ids_num, # ids of samples for every cell
                                                n_samples, # total number of samples
                                                group_ids_of_samples, # ids of groups (1 or 2) for every sample
                                                min_non_zero_cells, # min number of cells with > 0 expression in each group
                                                t(counts), 
                                                n_cores,
                                                as.matrix(design_covar))
      }else{
        # call non-parallel Rcpp code:
        p_val = .Call(`_distinct_perm_test_covariates`,
                      P_1, # number of permutations
                      P_2,
                      P_3,
                      P_4,
                      N_breaks, # number of breaks at which to evaluate the cdf
                      cluster_ids_num, # ids of clusters (cell-population) for every cell
                      n_clusters, # total number of clusters
                      sample_ids_num, # ids of samples for every cell
                      n_samples, # total number of samples
                      group_ids_of_samples, # ids of groups (1 or 2) for every sample
                      min_non_zero_cells, # min number of cells with > 0 expression in each group
                      t(counts),
                      as.matrix(design_covar))[[1]] # [[1]]: results returned as a 1 element list
      }
    }else{ # 2-group:
      if(n_cores > 1){
        # call a R wrapper, that parallelizes Rcpp code from R:
        p_val = perm_test_parallel_R(P_1, # number of permutations
                                     P_2,
                                     P_3,
                                     P_4,
                                     N_breaks, # number of breaks at which to evaluate the cdf
                                     cluster_ids_num, # ids of clusters (cell-population) for every cell
                                     sample_ids_num, # ids of samples for every cell
                                     n_samples, # total number of samples
                                     group_ids_of_samples, # ids of groups (1 or 2) for every sample
                                     min_non_zero_cells, # min number of cells with > 0 expression in each group
                                     t(counts), 
                                     n_cores)
      }else{
        # call non-parallel Rcpp code:
        p_val = .Call(`_distinct_perm_test`,
                      P_1, # number of permutations
                      P_2,
                      P_3,
                      P_4,
                      N_breaks, # number of breaks at which to evaluate the cdf
                      cluster_ids_num, # ids of clusters (cell-population) for every cell
                      n_clusters, # total number of clusters
                      sample_ids_num, # ids of samples for every cell
                      n_samples, # total number of samples
                      group_ids_of_samples, # ids of groups (1 or 2) for every sample
                      min_non_zero_cells, # min number of cells with > 0 expression in each group
                      t(counts) )[[1]] # [[1]]: results returned as a 1 element list
      }
    }
  }
  
  message("Differential testing completed, returning results")
  
  # store results which were filtered (due min_non_zero_cells filter)
  filtered = (p_val == -1)
  
  # set -1s to NA, so that we don't use these elements when adjusting p-values:
  p_val[ p_val == -1 ] = NA
  
  # locally adjusted p-values:
  res_adjusted_locally = apply(p_val, 2, p.adjust, method = "BH")
  
  filtered = c(filtered)
  p_val = c(p_val)
  res_adjusted_locally = c(res_adjusted_locally)
  # globally adjusted p-values:
  res_adjusted_globally = p.adjust(p_val, method = "BH")
  
  gene_names = rownames(counts)
  if(is.null(gene_names)){
    gene_names = seq_len(nrow(counts))
  }
  
  res = data.frame(
    gene = rep(gene_names, times = n_clusters),
    cluster_id = rep( levels(cluster_ids), each = nrow(counts) ),
    p_val = p_val,
    p_adj.loc = res_adjusted_locally,
    p_adj.glb = res_adjusted_globally,
    filtered = filtered
  )
  
  # set to 1 pvals (and adjusted pvals) which were NA (not analyzed:)
  res$p_val[is.na(res$p_val)] = 1
  res$p_adj.loc[is.na(res$p_adj.loc)] = 1
  res$p_adj.glb[is.na(res$p_adj.glb)] = 1
  
  res
}

test_that("distinct_test() works faultlessly.", {
  data("Kang_subset", package = "distinct")
  
  # create the design of the study:
  samples = Kang_subset@metadata$experiment_info$sample_id
  group = Kang_subset@metadata$experiment_info$stim
  design = model.matrix(~group)
  # rownames of the design must indicate sample ids:
  rownames(design) = samples
  
  set.seed(61217)
  res = distinct_test(
    x = Kang_subset, 
    name_assays_expression = "logcounts",
    name_cluster = "cell",
    design = design,
    column_to_test = 2,
    min_non_zero_cells = 20,
    n_cores = 2)
  
  expect_is(res, "data.frame")
})

# this is a R wrapper, to parallelize computation of distinct test via foreach:
perm_test_parallel_covariates_R = function(P, P_2, P_3, P_4, 
                                           N_breaks, cluster_ids, sample_ids, 
                                           n_samples, group_ids_of_samples, min_non_zero_cells, counts,
                                           n_cores, design_batches){
  suppressWarnings({
    cl <- makeCluster(n_cores, setup_strategy = "sequential")
  })
  registerDoParallel(cl, n_cores);
  
  # change the final_order to sort clusters by number of cells:
  final_order = order(table(cluster_ids), decreasing = TRUE) - 1
  # -1 because index goes from 0 to n-1 in C++!
  
  p_values_ALL = foreach(cl_id = final_order,
                         .packages=c("distinct", "Matrix"), # Matrix package needed to treat the sparce matrix
                         .errorhandling = "stop") %dorng%{
                           # select elements belonging to the cl_id-th cluster:
                           sel = cluster_ids == cl_id
                           
                           .Call(`_distinct_perm_test_parallel_covariates`,
                                 P,
                                 P_2,
                                 P_3,
                                 P_4,# number of permutations
                                 N_breaks, # number of breaks at which to evaluate the cdf
                                 sample_ids[sel], # ids of samples for every cell
                                 n_samples, # total number of samples
                                 group_ids_of_samples, # ids of groups (1 or 2) for every sample
                                 min_non_zero_cells, # min number of cells with > 0 expression in each group
                                 counts[ sel, ],
                                 design_batches)[[1]]
                         }
  stopCluster(cl)
  stopImplicitCluster()
  
  # order(final_order) will revert the original oder:
  do.call(cbind, p_values_ALL[order(final_order)])
}

#' Subset from the `Kang18_8vs8()` object of the \code{muscData} package.
#' 
#' @rdname Kang_subset
#' @name Kang_subset
#' @aliases Kang_subset
#' 
#' @param Kang_subset contains a \code{\linkS4class{SingleCellExperiment}} object, 
#' representing a subset of 6 samples (3 individuals observed across 2 conditions) and 100 genes selected from the `Kang18_8vs8()` object of the \code{muscData} package.
#' Below the code used to subset the original dataset.
#
#' @examples
#' #################### 
#' # Object 'Kang_subset' is generated as follows:
#' ####################
#' # library(muscData)
#' # sce = Kang18_8vs8()
#' # 
#' # library(scater)
#' # sce = computeLibraryFactors(sce)
#' # sce = logNormCounts(sce)
#' # cpm(sce) <- calculateCPM(sce)
#' # 
#' # Select genes with at least 1000 non-zero cells:
#' # sce = sce[ rowSums(assays(sce)$counts > 0) >= 1000, ]
#' # 
#' # randomly select 100 of these genes:
#' # set.seed(61217)
#' # sel = sample( rownames(sce), size = 100)
#' # sce = sce[ rownames(sce) %in% sel, ]
#' # 
#' # select 3 individuals only:
#' # ind_selected = levels(factor(colData(sce)$ind))[1:3]
#' # sce = sce[, sce$ind %in% ind_selected]
#' # 
#' # make a sample_id column:
#' # colData(sce)$sample_id = factor(paste(colData(sce)$stim, colData(sce)$ind, sep = "_"))
#' # 
#' # create an experiment_info object containing sample-group information:
#' # experiment_info = unique(data.frame(sample_id = colData(sce)$sample_id, 
#' #                                     stim = colData(sce)$stim) )
#' # metadata(sce)$experiment_info = data.frame(experiment_info, row.names = NULL)
#' # 
#' # remove unnecessary information to reduce storage space:
#' # sce$cluster = NULL;
#' # sce$multiplets = NULL;
#' # rowData(sce) = NULL;
#' # colnames(sce) = NULL;
#' # reducedDim(sce) = NULL
#' # sce$ind = NULL
#' # sce$sizeFactor = NULL
#' # rm assays counts
#' # assays(sce) = assays(sce)[2:3]
#' #
#' # Kang_subset = sce
#' # save(Kang_subset, file = "Kang_subset.RData")
#' @author Simone Tiberi \email{simone.tiberi@uzh.ch}
#' 
#' @seealso \code{\link{distinct_test}}
NULL

#' @useDynLib distinct, .registration=TRUE
#' @importFrom scater sumCountsAcrossCells
#' @importFrom limma is.fullrank
#' @importFrom stats p.adjust
#' @importFrom methods is
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment assays
#' @importFrom SummarizedExperiment colData
#' @importFrom Matrix Matrix
#' @importFrom Matrix rowSums
#' @importFrom Matrix t
#' @importFrom foreach foreach
#' @importFrom foreach '%dopar%'
#' @importFrom parallel makeCluster
#' @importFrom parallel stopCluster
#' @importFrom doParallel registerDoParallel
#' @importFrom doParallel stopImplicitCluster
#' @importFrom doRNG '%dorng%'
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 element_blank
#' @importFrom ggplot2 geom_hline
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 stat_ecdf
#' @importFrom ggplot2 geom_density
#' @importFrom ggplot2 stat_density
#' @importFrom ggplot2 theme
#' @importFrom ggplot2 theme_bw
#' @importFrom ggplot2 labs
NULL

#' Compute FCs and log2-FCs.
#'
#' \code{log2_FC} extends the results obtained via \code{\link{distinct_test}}, by computing fold changes (FC) and log2-FC between conditions.
#' 
#' @param res a \code{\linkS4class{data.frame}} with results as returned from \code{\link{distinct_test}}.
#' @param x a \code{linkS4class{SummarizedExperiment}} or a \code{linkS4class{SingleCellExperiment}} object.
#' @param name_assays_expression a character ("cpm" by default), 
#' indicating the name of the assays(x) element which stores the expression data (i.e., assays(x)$name_assays_expression).
#' We strongly encourage using normalized data, such as counts per million (CPM).
#' Do not use logarithm transformed data to compute FCs.
#' @param name_group a character ("group_id" by default), 
#' indicating the name of the colData(x) element which stores the group id of each cell (i.e., colData(x)$name_group).
#' @param name_cluster a character ("cluster_id" by default), 
#' indicating the name of the colData(x) element which stores the cluster id of each cell (i.e., colData(x)$name_cluster).
#' @return A \code{\linkS4class{data.frame}} object, extending the results in `res`.
#' Two additional columns are added: FC_group1/group2 and log2FC_group1/group2, inicating the FC and log2-FC of group1/group2.
#' A FC > 1 (or log2FC > 0) indicates up-regulation of group1 (compared to group2); while a FC < 1 (or log2FC < 0) indicates down-regulation of group1 (compared to group2).
#' @examples
#' # load pre-computed results (obtaines via `distinct_test`)
#' data("res", package = "distinct")
#' # load the input data:
#' data("Kang_subset", package = "distinct")
#' 
#' # We can optionally add the fold change (FC) and log2-FC between groups:
#' res = log2_FC(res = res,
#'   x = Kang_subset, 
#'   name_assays_expression = "cpm",
#'   name_group = "stim",
#'   name_cluster = "cell")
#' 
#' # Visualize significant results:
#' head(top_results(res))
#' 
#' @author Simone Tiberi \email{simone.tiberi@uzh.ch}
#' 
#' @seealso \code{\link{distinct_test}}, \code{\link{top_results}}
#' 
#' @export
log2_FC = function(res, 
                   x, 
                   name_assays_expression = "cpm",
                   name_group = "group_id",
                   name_cluster = "cluster_id"
){
  stopifnot(
    is.data.frame(res),
    ( is(x, "SummarizedExperiment") | is(x, "SingleCellExperiment") ),
    is.character(name_assays_expression), length(name_assays_expression) == 1L,
    is.character(name_group), length(name_group) == 1L,
    is.character(name_cluster), length(name_cluster) == 1L
  )
  
  # check if FC/log2_FC are already present in res:
  sel_FC_cols = grep("FC", colnames(res))
  if( length(sel_FC_cols) > 0 ){
    message("'res' already contains columns 'FC' and/or 'log2FC': they will be overwritten")
    res = res[,-sel_FC_cols]
  }
  sel_mean_cols = grep("mean", colnames(res))
  if( length(sel_mean_cols) > 0 ){
    res = res[,-sel_mean_cols]
  }
  
  
  # count matrix:
  sel = which(names(assays(x)) == name_assays_expression)
  if( length(sel) == 0 ){
    message("'name_assays_expression' not found in names(assays(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'name_assays_expression' found multiple times in names(assays(x))")
    return(NULL)
  }
  counts = assays(x)[[sel]]
  
  # cluster ids:
  sel = which(names(colData(x)) == name_cluster)
  if( length(sel) == 0 ){
    message("'name_cluster' not found in names(colData(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'name_cluster' found multiple times in names(colData(x))")
    return(NULL)
  }
  cluster_ids = colData(x)[[sel]]
  
  # group ids (1 per cell)
  sel = which(names(colData(x)) == name_group)
  if( length(sel) == 0 ){
    message("'name_group' not found in names(colData(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'name_group' found multiple times in names(colData(x))")
    return(NULL)
  }
  group_ids = factor(colData(x)[[sel]])
  
  # TODO: GET GROUP
  group_levels = levels(group_ids)
  
  if(length(group_levels) != 2){
    message("2 groups have to be provided in colData(x)$name_group")
    return(NULL)
  }
  
  group_1 = group_ids == group_levels[1]
  group_2 = group_ids == group_levels[2]
  
  pb_1 = assays(sumCountsAcrossCells(x = counts[,group_1],
                                     ids = cluster_ids[group_1],
                                     average = TRUE))$average
  # average computes the MEAN expression across cells (it divides by the number of cells in each cluster)
  
  pb_2 = assays(sumCountsAcrossCells(x = counts[,group_2],
                                     ids = cluster_ids[group_2],
                                     average = TRUE))$average
  
  # store cluster and gene names:
  n_genes = nrow(pb_1)
  
  cluster_levels = intersect(colnames(pb_1),colnames(pb_2))
  
  # in each cluster, compute the mean for groups 1 and 2 (and FC-log2FC)
  FC_by_cluster = lapply(seq_along(cluster_levels), function(i){
    exp_1 = pb_1[,i]
    exp_2 = pb_2[,i]
    FC = exp_1/exp_2
    log2_FC = log2(FC)
    
    cbind( cluster_num = i, gene_num = seq_len(n_genes), exp_1, exp_2, FC, log2_FC)
  })
  FC_by_cluster = do.call(rbind,FC_by_cluster)
  
  # numeric transformations of res and cluster from "res":
  cluster_res_num = as.numeric(factor(res$cluster_id, levels =  cluster_levels ))
  gene_res_num = as.numeric(factor(res$gene, levels = rownames(pb_1)))
  
  # paste cluster and gene in res:
  cluster_gene_res = paste(cluster_res_num, gene_res_num, sep=".")
  
  # paste cluster and gene in FC_by_cluster
  cluster_gene_FC = paste(FC_by_cluster[,1], FC_by_cluster[,2], sep=".")
  
  matching = match(cluster_gene_res, cluster_gene_FC)
  tmp = FC_by_cluster[matching, 3:6 ]
  
  colnames(tmp) = c( paste0("mean_", group_levels[1]),
                     paste0("mean_", group_levels[2]),
                     paste0("FC_", group_levels[1], "/", group_levels[2]),
                     paste0("log2FC_", group_levels[1], "/", group_levels[2]) )
  rownames(tmp) = NULL
  
  res_final = cbind(res, tmp)
  
  message("FC and log2_FC computed, returning results")
  
  res_final
}

test_that("log2_FC() works faultlessly.", {
  # load pre-computed results (obtaines via `distinct_test`)
  data("res", package = "distinct")
  # load the input data:
  data("Kang_subset", package = "distinct")
  
  # We can optionally add the fold change (FC) and log2-FC between groups:
  res = log2_FC(res = res,
                x = Kang_subset, 
                name_assays_expression = "cpm",
                name_group = "stim",
                name_cluster = "cell")
  
  expect_is(res, "data.frame")
})

#' Plot sample-specific CDFs.
#'
#' \code{plot_cdfs} returns a \code{\link{ggplot}} object
#' with the sample-specific cumulative density function (CDF) estimates, for a specified cluster and gene.
#' 
#' @param x a \code{\linkS4class{SummarizedExperiment}} or a \code{\linkS4class{SingleCellExperiment}} object.
#' @param name_assays_expression a character ("logcounts" by default), 
#' indicating the name of the assays(x) element which stores the expression data (i.e., assays(x)$name_assays_expression).
#' We strongly encourage using normalized data, such as counts per million (CPM) or log-CPM.
#' @param name_cluster a character ("cluster_id" by default), 
#' indicating the name of the colData(x) element which stores the cluster id of each cell (i.e., colData(x)$name_colData_cluster).
#' @param name_sample a character ("sample_id" by default), 
#' indicating the name of the colData(x) element which stores the sample id of each cell (i.e., colData(x)$name_colData_sample).
#' @param name_group a character ("group_id" by default), 
#' indicating the name of the colData(x) element which stores the group id of each cell (i.e., colData(x)$name_colData_group).
#' @param cluster a character, indicating the name of the cluster to plot.
#' @param gene a character, indicating the name of the gene to plot.
#' @param group_level a logical, indicating whether to plot group-level (if TRUE) or sample-level curves (if FALSE).
#' @param pad a logical element indicating whether to plot the lines of the CDF when 0 and 1 (TRUE) or not (FALSE).
#' @param size a numeric argument defining the width of lines, passed to \code{\link{stat_ecdf}}.
#' @return A \code{\link{ggplot}} object.
#' @examples
#' data("Kang_subset", package = "distinct")
#' Kang_subset
#' 
#' plot_cdfs(x = Kang_subset,
#'           gene = "ISG15",
#'           cluster = "Dendritic cells",
#'           name_assays_expression = "logcounts",
#'           name_cluster = "cell",
#'           name_sample = "sample_id",
#'           name_group = "stim")
#' 
#' @author Simone Tiberi \email{simone.tiberi@uzh.ch}
#' 
#' @seealso \code{\link{distinct_test}}, \code{\link{plot_densities}}
#' 
#' @export
plot_cdfs = function(x, 
                     name_assays_expression = "logcounts",
                     name_cluster = "cluster_id",
                     name_sample = "sample_id",
                     name_group = "group_id",
                     cluster,
                     gene,
                     group_level = FALSE,
                     pad = TRUE,
                     size = 0.75){
  
  stopifnot(
    ( is(x, "SummarizedExperiment") | is(x, "SingleCellExperiment") ),
    is.character(name_assays_expression), length(name_assays_expression) == 1L,
    is.character(name_cluster), length(name_cluster) == 1L,
    is.character(name_sample), length(name_sample) == 1L,
    is.character(name_group), length(name_group) == 1L,
    is.character(cluster), length(cluster) == 1L,
    is.character(gene), length(gene) == 1L,
    is.logical(group_level), length(group_level) == 1L
  )
  
  # count matrix:
  sel = which(names(assays(x)) == name_assays_expression)
  if( length(sel) == 0 ){
    message("'name_assays_expression' not found in names(assays(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'name_assays_expression' found multiple times in names(assays(x))")
    return(NULL)
  }
  counts = assays(x)[[sel]]
  
  # cluster ids:
  sel = which(names(colData(x)) == name_cluster)
  if( length(sel) == 0 ){
    message("'name_cluster' not found in names(colData(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'name_cluster' found multiple times in names(colData(x))")
    return(NULL)
  }
  cluster_ids = colData(x)[[sel]]
  
  # sample ids:
  if(!group_level){
    sel = which(names(colData(x)) == name_sample)
    if( length(sel) == 0 ){
      message("'name_sample' not found in names(colData(x))")
      return(NULL)
    }
    if( length(sel) > 1 ){
      message("'name_sample' found multiple times in names(colData(x))")
      return(NULL)
    }
    sample_ids = factor(colData(x)[[sel]])
  }
  
  # group ids (1 per cell)
  sel = which(names(colData(x)) == name_group)
  if( length(sel) == 0 ){
    message("'name_group' not found in names(colData(x))")
    return(NULL)
  }
  if( length(sel) > 1 ){
    message("'name_group' found multiple times in names(colData(x))")
    return(NULL)
  }
  group_ids = factor(colData(x)[[sel]])
  
  # sel gene:
  sel_gene = rownames(x) == gene
  sel_gene[is.na(sel_gene)] = FALSE
  
  if( all(!sel_gene) ){ # if all sel_gene FALSE:
    message("'gene' not found in `rownames(x)`")
    return(NULL)
  }
  
  # sel cluster:
  sel_cluster = cluster_ids == cluster
  sel_cluster[is.na(sel_cluster)] = FALSE
  
  if( all(!sel_cluster) ){ # if all sel_gene FALSE:
    message("'cluster' not found in `colData(x)[[name_cluster]]`")
    return(NULL)
  }
  
  
  if(group_level){
    DF = data.frame(x = counts[sel_gene, sel_cluster], 
                    group = group_ids[sel_cluster])
    gg = ggplot(DF, aes(x=x, group=group, colour = group))
  }else{
    DF = data.frame(x = counts[sel_gene, sel_cluster], 
                    group = group_ids[sel_cluster],
                    sample = sample_ids[sel_cluster])
    gg = ggplot(DF, aes(x=x, group=sample, colour = group))
  }
  
  # Density plot:
  gg +
    geom_hline(yintercept=0, linetype="dashed", color = "grey") +
    geom_hline(yintercept=1, linetype="dashed", color = "grey") +
    stat_ecdf(pad = pad, size = size) +
    theme_bw() + 
    theme(panel.grid = element_blank()) +
    labs(title = paste(cluster, "-", gene),
         x = name_assays_expression,
         y = "CDF")
}

## ----setup, echo=FALSE, results="hide"----------------------------------------
knitr::opts_chunk$set(tidy=FALSE, cache=TRUE,
                      dev="png",
                      message=TRUE, error=FALSE, warning=TRUE)

## ----vignettes, eval=FALSE----------------------------------------------------
# browseVignettes("distinct")

## ----citation, eval=FALSE-----------------------------------------------------
# citation("distinct")

## ----Bioconductor_installation, eval=FALSE------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#   install.packages("BiocManager")
# BiocManager::install("distinct")

## ----load-example-data, message = FALSE---------------------------------------
library(SingleCellExperiment)
data("Kang_subset", package = "distinct")
Kang_subset

## ----visualize colData--------------------------------------------------------
colData(Kang_subset)

## ----visualize experimental design--------------------------------------------
Kang_subset@metadata$experiment_info

## ----load_distinct, message=FALSE---------------------------------------------
library(distinct)

## ----create_design------------------------------------------------------------
samples = Kang_subset@metadata$experiment_info$sample_id
group = Kang_subset@metadata$experiment_info$stim
design = model.matrix(~group)
# rownames of the design must indicate sample ids:
rownames(design) = samples
design

## ----check_sample_names-------------------------------------------------------
rownames(design)

unique(colData(Kang_subset)$sample_id)

## ----differential-analyses----------------------------------------------------
set.seed(61217)

res = distinct_test(x = Kang_subset, 
                    name_assays_expression = "logcounts",
                    name_cluster = "cell",
                    name_sample = "sample_id",
                    design = design,
                    column_to_test = 2,
                    min_non_zero_cells = 20,
                    n_cores = 2)

## ----define-batches-----------------------------------------------------------
batch = factor(c("A", "B", "C", "A", "B", "C"))

design = model.matrix(~group + batch)
# rownames of the design must indicate sample ids:
rownames(design) = samples
design

## ----differential-analyses-with-batches---------------------------------------
set.seed(61217)

res_batches = distinct_test(x = Kang_subset, 
                            name_assays_expression = "logcounts",
                            name_cluster = "cell",
                            name_sample = "sample_id",
                            design = design,
                            column_to_test = 2,
                            min_non_zero_cells = 20,
                            n_cores = 2)

## ----compute-log2_FC----------------------------------------------------------
res = log2_FC(res = res,
              x = Kang_subset, 
              name_assays_expression = "cpm",
              name_group = "stim",
              name_cluster = "cell")

## ----visualize-group-levels---------------------------------------------------
levels(colData(Kang_subset)$stim)
head(res[,9:10], 3)

## ----reorder-group-levels-----------------------------------------------------
# set "stim" as 1st level:
colData(Kang_subset)$stim = relevel(colData(Kang_subset)$stim, "stim")
levels(colData(Kang_subset)$stim)

res_2 = log2_FC(res = res,
              x = Kang_subset, 
              name_assays_expression = "cpm",
              name_group = "stim",
              name_cluster = "cell")

head(res_2[,9:10], 3)

## ----visualize-results--------------------------------------------------------
head(top_results(res))

## ----visualize-results-one-cluster--------------------------------------------
top_results(res, cluster = "Dendritic cells")

## ----visualize-results-one-cluster-sort-by-FC---------------------------------
top_results(res, cluster = "Dendritic cells", sort_by = "log2FC")

## ----visualize-results-down---------------------------------------------------
top_results(res, up_down = "down",
            cluster = "Dendritic cells")

## ----plot_densitied-----------------------------------------------------------
plot_densities(x = Kang_subset,
               gene = "ISG15",
               cluster = "Dendritic cells",
               name_assays_expression = "logcounts",
               name_cluster = "cell",
               name_sample = "sample_id",
               name_group = "stim")

## ----plot_densitied_group_level-----------------------------------------------
plot_densities(x = Kang_subset,
               gene = "ISG15",
               cluster = "Dendritic cells",
               name_assays_expression = "logcounts",
               name_cluster = "cell",
               name_sample = "sample_id",
               name_group = "stim",
               group_level = TRUE)

## ----plot_cdfs----------------------------------------------------------------
plot_cdfs(x = Kang_subset,
          gene = "ISG15",
          cluster = "Dendritic cells",
          name_assays_expression = "logcounts",
          name_cluster = "cell",
          name_sample = "sample_id",
          name_group = "stim")

## ----plotExpression-----------------------------------------------------------
# select cluster of cells:
cluster = "Dendritic cells"
sel_cluster = res$cluster_id == cluster
sel_column = Kang_subset$cell == cluster

# select significant genes:
sel_genes = res$p_adj.glb < 0.01
genes = as.character(res$gene[sel_cluster & sel_genes])

# make violin plots:
library(scater)
plotExpression(Kang_subset[,sel_column],
               features = genes, exprs_values = "logcounts",
               log2_values = FALSE,
               x = "sample_id", colour_by = "stim", ncol = 3) +
  guides(fill = guide_legend(override.aes = list(size = 5, alpha = 1))) +
  theme(axis.text.x = element_text(angle = 45, hjust = 1))

## ----UpsetR plot--------------------------------------------------------------
library(UpSetR)
res_by_cluster = split( ifelse(res$p_adj.glb < 0.01, 1, 0), res$cluster_id)
upset(data.frame(do.call(cbind, res_by_cluster)), nsets = 10, nintersects = 20)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Results from \code{\link{distinct_test}} function
#' 
#' @rdname res
#' @name res
#' @aliases res
#' 
#' @param res contains a \code{\linkS4class{data.frame}} object,
#' with the results obtained applying \code{\link{distinct_test}} function to \code{\link{Kang_subset}} dataset.
#' Below the code used to obtain `res`.
#
#' @examples
#' # load the input data:
#' # data("Kang_subset", package = "distinct")
#' # Kang_subset
#' # 
#' # create the design of the study:
#' # samples = Kang_subset@metadata$experiment_info$sample_id
#' # group = Kang_subset@metadata$experiment_info$stim
#' # design = model.matrix(~group)
#' # rownames of the design must indicate sample ids:
#' # rownames(design) = samples
#' # design
#' # 
#' # Note that the sample names in `colData(x)$name_sample` have to be the same ones as those in `rownames(design)`.
#' # rownames(design)
#' # unique(SingleCellExperiment::colData(Kang_subset)$sample_id)
#' # 
#' # In order to obtain a finer ranking for the most significant genes, if computational resources are available, we encourage users to increase P_4 (i.e., the number of permutations when a raw p-value is < 0.001) and set P_4 = 20,000 (by default P_4 = 10,000).
#' # 
#' # The group we would like to test for is in the second column of the design, therefore we will specify: column_to_test = 2
#' # 
#' # set.seed(61217)
#' # res = distinct_test(
#' #   x = Kang_subset, 
#' #   name_assays_expression = "logcounts",
#' #   name_cluster = "cell",
#' #   design = design,
#' #   column_to_test = 2,
#' #   min_non_zero_cells = 20,
#' #   n_cores = 2)
#' #   
#' #   save(res, file = "res.RData")
#' #   saveRDS(res, file = "res.rds")
#' @author Simone Tiberi \email{simone.tiberi@uzh.ch}
#' 
#' @seealso \code{\link{distinct_test}}
NULL

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

perm_test <- function(P, P_2, P_3, P_4, N_breaks, cluster_ids, n_clusters, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts) {
    .Call(`_distinct_perm_test`, P, P_2, P_3, P_4, N_breaks, cluster_ids, n_clusters, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts)
}

perm_test_covariates <- function(P, P_2, P_3, P_4, N_breaks, cluster_ids, n_clusters, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts, design) {
    .Call(`_distinct_perm_test_covariates`, P, P_2, P_3, P_4, N_breaks, cluster_ids, n_clusters, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts, design)
}

perm_test_parallel_covariates <- function(P, P_2, P_3, P_4, N_breaks, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts, design) {
    .Call(`_distinct_perm_test_parallel_covariates`, P, P_2, P_3, P_4, N_breaks, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts, design)
}

perm_test_parallel <- function(P, P_2, P_3, P_4, N_breaks, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts) {
    .Call(`_distinct_perm_test_parallel`, P, P_2, P_3, P_4, N_breaks, sample_ids, n_samples, group_ids_of_samples, min_non_zero_cells, counts)
}

test_that("plot_densities() works faultlessly.", {
  data("Kang_subset", package = "distinct")
  Kang_subset
  
  res = plot_densities(x = Kang_subset,
            gene = "ISG15",
            cluster = "Dendritic cells",
            name_assays_expression = "logcounts",
            name_cluster = "cell",
            name_sample = "sample_id",
            name_group = "stim")
  
  expect_is(res, "ggplot")
})

---
title: "distinct: a method for differential analyses via hierarchical permutation tests"
author:
- name: Simone Tiberi
  affiliation:
  - &IMLS Institute for Molecular Life Sciences, University of Zurich, Switzerland
  - &SIB SIB Swiss Institute of Bioinformatics, University of Zurich, Switzerland
  email: simone.tiberi@uzh.ch
package: "`r BiocStyle::pkg_ver('distinct')`"
date: "`r format(Sys.Date(), '%m/%d/%Y')`"
bibliography: References.bib
vignette: >
  %\VignetteIndexEntry{distinct: a method for differential analyses via hierarchical permutation tests}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output: 
  BiocStyle::html_document
---

---

```{r setup, echo=FALSE, results="hide"}
knitr::opts_chunk$set(tidy=FALSE, cache=TRUE,
                      dev="png",
                      message=TRUE, error=FALSE, warning=TRUE)
```

# Introduction
*distinct* is a statistical method to perform differential testing between two or more groups of distributions; differential testing is performed via hierarchical non-parametric permutation tests on the cumulative distribution functions (cdfs) of each sample.
While most methods for differential expression target differences in the mean abundance between conditions, *distinct*, by comparing full cdfs, identifies, both, differential patterns involving changes in the mean, as well as more subtle variations that do not involve the mean (e.g., unimodal vs. bi-modal distributions with the same mean).
*distinct* is a general and flexible tool: due to its fully non-parametric nature, which makes no assumptions on how the data was generated, it can be applied to a variety of datasets.
It is particularly suitable to perform differential state analyses on single cell data (e.g., differential analyses within sub-populations of cells), such as single cell RNA sequencing (scRNA-seq) and high-dimensional flow or mass cytometry (HDCyto) data.

At present, covariates are not allowed, and only 2-group comparisons are implemented.
In future releases, we will allow for covariates and for differential testing between more than 2 groups.

A pre-print will follow in the coming months.

To access the R code used in the vignettes, type:
```{r vignettes, eval=FALSE} 
browseVignettes("distinct")
```

Questions relative to *distinct* should be reported as a new issue at *[BugReports](https://github.com/SimoneTiberi/distinct/issues)*.

To cite *distinct*, type:
```{r citation, eval=FALSE} 
citation("distinct")
```

## Bioconductor installation
*distinct* is available on [Bioconductor](https://bioconductor.org/packages/distinct) and can be installed with the command:
```{r Bioconductor_installation, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
  install.packages("BiocManager")
BiocManager::install("distinct")
```

# Differential State analysis
Differential state analyses aim at investigating differential patterns between conditions in sub-populations of cells.
To use *distinct* one needs data from two or more groups of samples (i.e., experimental conditions), with at least 2 samples (i.e., biological replicates) per group.
Given a single-cell RNA-sequencing (scRNA-seq) or a high dimensional flow or mass cytometry (HDCyto) dataset, cells need first to be clustered in groups via some form of clustering algorithms; *distinct* is then applied to identify differential patterns between groups, within each cluster of cells.

## Input data
Load the example dataset, consisting of a subset of 6 samples (3 individuals observed across 2 conditions) and 100 genes selected from the `Kang18_8vs8()` object of the *muscData* package.
```{r load-example-data, message = FALSE}
library(SingleCellExperiment)
data("Kang_subset", package = "distinct")
Kang_subset
```

Columns `ind` and `stim` of the `colData` indicate the indivual id and the experimental condition (control or stimulated) of each cell, while column `sample_id` shows the sample id, needed for the differential anlyses.
Column `cell` represents the cell type, which defines the clustering structure of cells: differential testing between conditions is performed separately for each cluster of cells.
Note that, if cell clustering label was unknown, we would need to cluster cells into groups via some clustering algorithm.
```{r visualize colData}
colData(Kang_subset)
```

The experimental design compares two groups (stim vs ctrl) with 3 biological replicates each.
```{r visualize experimental design}
Kang_subset@metadata$experiment_info
```

## Differential analyses within sub-populations of cells
Load *distinct*.
```{r load_distinct, message=FALSE}
library(distinct)
```

Create the design of the study:
```{r create_design}
samples = Kang_subset@metadata$experiment_info$sample_id
group = Kang_subset@metadata$experiment_info$stim
design = model.matrix(~group)
# rownames of the design must indicate sample ids:
rownames(design) = samples
design
```

Perform differential state testing between conditions.
Parameter `name_assays_expression` specifies the input data (logcounts) in `assays(x)`, while `name_cluster` and `name_sample` define the column names of `colData(x)` containing the clustering of cells (cell) and the id of individual samples (sample_id).
The group we would like to test for is in the second column of the design, therefore we will specify: column_to_test = 2.

Note that the sample names in `colData(x)$name_sample` have to be the same ones as those in `rownames(design)` (although not necessarily in the same order).
```{r check_sample_names}
rownames(design)

unique(colData(Kang_subset)$sample_id)
```

In order to obtain a finer ranking for the most significant genes, if computational resources are available, we encourage users to increase `P_4` (i.e., the number of permutations when a raw p-value is < 0.001) and set `P_4 = 20,000` (by default  `P_4 = 10,000`).

We strongly encourage using normalized data, such as counts per million (CPM) or log2-CPM (e.g.,   `logcounts` as created via `scater::logNormCounts`).
```{r differential-analyses}
set.seed(61217)

res = distinct_test(x = Kang_subset, 
                    name_assays_expression = "logcounts",
                    name_cluster = "cell",
                    name_sample = "sample_id",
                    design = design,
                    column_to_test = 2,
                    min_non_zero_cells = 20,
                    n_cores = 2)
```

### Handling covariates and batch effects
Covariates (such as batch effects), if present, can be added to the design matrix.
In each cluster of cells, we fit a linear model, with covariates as predictors, and regress them out by performing differential analyeses on the residuals.
By separately fitting a linear model on each cluster, we allow the effect of covariates to vary from cluster to cluster.

When specifying covariates, we highly recommend using log-normalized data, such as log2-CPMs (e.g., `logcounts` as created via `scater::logNormCounts`), because it is generally assumed that covariates (and particularly batch effects) have an approximately linear effect on the log or log2 scale of counts.

Assume samples are associated to three different batches; we modify the design to also include batches.
```{r define-batches}
batch = factor(c("A", "B", "C", "A", "B", "C"))

design = model.matrix(~group + batch)
# rownames of the design must indicate sample ids:
rownames(design) = samples
design
```

We proceed as before to perform differential testing.
Again, we specify the column of the design to be tested via `column_to_test = 2`.
```{r differential-analyses-with-batches}
set.seed(61217)

res_batches = distinct_test(x = Kang_subset, 
                            name_assays_expression = "logcounts",
                            name_cluster = "cell",
                            name_sample = "sample_id",
                            design = design,
                            column_to_test = 2,
                            min_non_zero_cells = 20,
                            n_cores = 2)
```

## Visualizing results
Results are reported as a `data.frame`, where columns `gene` and `cluster_id` contain the gene and cell-cluster name, while `p_val`, `p_adj.loc` and `p_adj.glb` report the raw p-values, locally and globally adjusted p-values, via Benjamini and Hochberg (BH) correction.
In locally adjusted p-values (`p_adj.loc`) BH correction is applied in each cluster separately, while in globally adjusted p-values (`p_adj.glb`) BH correction is performed to the results from all clusters.

We can further compute the fold change (FC) and log2-FC between groups.
To compute FCs, use normalized data, such as CPMs; do not use logarithm transformed data (e.g., logcounts).
```{r compute-log2_FC}
res = log2_FC(res = res,
              x = Kang_subset, 
              name_assays_expression = "cpm",
              name_group = "stim",
              name_cluster = "cell")
```

`log2_FC` computes the log-FC between the first and the second level of the group id, in this case beween controls (numerator) and stimulated samples (denominator).
```{r visualize-group-levels}
levels(colData(Kang_subset)$stim)
head(res[,9:10], 3)
```

To use a different level (i.e., stim/ctrl), we can reorder the levels before running `log2_FC2`.
```{r reorder-group-levels}
# set "stim" as 1st level:
colData(Kang_subset)$stim = relevel(colData(Kang_subset)$stim, "stim")
levels(colData(Kang_subset)$stim)

res_2 = log2_FC(res = res,
              x = Kang_subset, 
              name_assays_expression = "cpm",
              name_group = "stim",
              name_cluster = "cell")

head(res_2[,9:10], 3)
```

We can visualize significant results via `top_results` function.
```{r visualize-results}
head(top_results(res))
```

We can also visualize significant results for a specific cluster of cells.
```{r visualize-results-one-cluster}
top_results(res, cluster = "Dendritic cells")
```

By default, results from 'top_results' are sorted by (globally) adjusted p-value; they can also be sorted by log2-FC.
```{r visualize-results-one-cluster-sort-by-FC}
top_results(res, cluster = "Dendritic cells", sort_by = "log2FC")
```

We can further filter results to visualize significant up- or down-regulated results only.
Here we visualize the down-regulated gene-cluster results; i.e., results with lower expression in 'ctlr' group compared to 'stim'.
```{r visualize-results-down}
top_results(res, up_down = "down",
            cluster = "Dendritic cells")
```


## Plotting significant results
Density plot of one significant gene (ISG15) in `Dendritic cells` cluster.
```{r plot_densitied}
plot_densities(x = Kang_subset,
               gene = "ISG15",
               cluster = "Dendritic cells",
               name_assays_expression = "logcounts",
               name_cluster = "cell",
               name_sample = "sample_id",
               name_group = "stim")
```

Instead of one curve per sample, we can also plot aggregated group-level curves by setting `group_level = TRUE`.
```{r plot_densitied_group_level}
plot_densities(x = Kang_subset,
               gene = "ISG15",
               cluster = "Dendritic cells",
               name_assays_expression = "logcounts",
               name_cluster = "cell",
               name_sample = "sample_id",
               name_group = "stim",
               group_level = TRUE)
```

CDF plot of one significant gene (ISG15) in `Dendritic cells` cluster.
```{r plot_cdfs}
plot_cdfs(x = Kang_subset,
          gene = "ISG15",
          cluster = "Dendritic cells",
          name_assays_expression = "logcounts",
          name_cluster = "cell",
          name_sample = "sample_id",
          name_group = "stim")
```

Violin plots of significant genes in `Dendritic cells` cluster.
```{r plotExpression}
# select cluster of cells:
cluster = "Dendritic cells"
sel_cluster = res$cluster_id == cluster
sel_column = Kang_subset$cell == cluster

# select significant genes:
sel_genes = res$p_adj.glb < 0.01
genes = as.character(res$gene[sel_cluster & sel_genes])

# make violin plots:
library(scater)
plotExpression(Kang_subset[,sel_column],
               features = genes, exprs_values = "logcounts",
               log2_values = FALSE,
               x = "sample_id", colour_by = "stim", ncol = 3) +
  guides(fill = guide_legend(override.aes = list(size = 5, alpha = 1))) +
  theme(axis.text.x = element_text(angle = 45, hjust = 1))
```

Visualize the concordance of differential results between cell clusters.
We select as significant genes with globally adjusted p-value below 0.01.
```{r UpsetR plot}
library(UpSetR)
res_by_cluster = split( ifelse(res$p_adj.glb < 0.01, 1, 0), res$cluster_id)
upset(data.frame(do.call(cbind, res_by_cluster)), nsets = 10, nintersects = 20)
```
# Session info
```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/log2_FC.R
\name{log2_FC}
\alias{log2_FC}
\title{Compute FCs and log2-FCs.}
\usage{
log2_FC(
  res,
  x,
  name_assays_expression = "cpm",
  name_group = "group_id",
  name_cluster = "cluster_id"
)
}
\arguments{
\item{res}{a \code{\linkS4class{data.frame}} with results as returned from \code{\link{distinct_test}}.}

\item{x}{a \code{linkS4class{SummarizedExperiment}} or a \code{linkS4class{SingleCellExperiment}} object.}

\item{name_assays_expression}{a character ("cpm" by default), 
indicating the name of the assays(x) element which stores the expression data (i.e., assays(x)$name_assays_expression).
We strongly encourage using normalized data, such as counts per million (CPM).
Do not use logarithm transformed data to compute FCs.}

\item{name_group}{a character ("group_id" by default), 
indicating the name of the colData(x) element which stores the group id of each cell (i.e., colData(x)$name_group).}

\item{name_cluster}{a character ("cluster_id" by default), 
indicating the name of the colData(x) element which stores the cluster id of each cell (i.e., colData(x)$name_cluster).}
}
\value{
A \code{\linkS4class{data.frame}} object, extending the results in `res`.
Two additional columns are added: FC_group1/group2 and log2FC_group1/group2, inicating the FC and log2-FC of group1/group2.
A FC > 1 (or log2FC > 0) indicates up-regulation of group1 (compared to group2); while a FC < 1 (or log2FC < 0) indicates down-regulation of group1 (compared to group2).
}
\description{
\code{log2_FC} extends the results obtained via \code{\link{distinct_test}}, by computing fold changes (FC) and log2-FC between conditions.
}
\examples{
# load pre-computed results (obtaines via `distinct_test`)
data("res", package = "distinct")
# load the input data:
data("Kang_subset", package = "distinct")

# We can optionally add the fold change (FC) and log2-FC between groups:
res = log2_FC(res = res,
  x = Kang_subset, 
  name_assays_expression = "cpm",
  name_group = "stim",
  name_cluster = "cell")

# Visualize significant results:
head(top_results(res))

}
\seealso{
\code{\link{distinct_test}}, \code{\link{top_results}}
}
\author{
Simone Tiberi \email{simone.tiberi@uzh.ch}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distinct_test.R
\name{distinct_test}
\alias{distinct_test}
\title{Test for differential state between two groups of samples, based on scRNA-seq data.}
\usage{
distinct_test(
  x,
  name_assays_expression = "logcounts",
  name_cluster = "cluster_id",
  name_sample = "sample_id",
  design,
  column_to_test = 2,
  P_1 = 100,
  P_2 = 500,
  P_3 = 2000,
  P_4 = 10000,
  N_breaks = 25,
  min_non_zero_cells = 20,
  n_cores = 1
)
}
\arguments{
\item{x}{a \code{linkS4class{SummarizedExperiment}} or a \code{linkS4class{SingleCellExperiment}} object.}

\item{name_assays_expression}{a character ("logcounts" by default), 
indicating the name of the assays(x) element which stores the expression data (i.e., assays(x)$name_assays_expression).
We strongly encourage using normalized data, such as counts per million (CPM) or log2-CPM (e.g., 'logcounts' as created via \code{scater::logNormCounts}).
In case additional covariates are provided (e.g., batch effects), we highly recommend using log-normalized data, such as log2-CPM (e.g., 'logcounts' as created via \code{scater::logNormCounts}).}

\item{name_cluster}{a character ("cluster_id" by default), 
indicating the name of the colData(x) element which stores the cluster id of each cell (i.e., colData(x)$name_cluster).}

\item{name_sample}{a character ("sample_id" by default), 
indicating the name of the colData(x) element which stores the sample id of each cell (i.e., colData(x)$name_sample).}

\item{design}{a \code{\linkS4class{matrix}} or \code{\linkS4class{data.frame}} with the design matrix of the study (e.g., built via model.matrix(~batches), 
design must contain one row per sample, while columns include intercept, group and eventual covariates such as batches.
Row names of design must indicate the sample ids, and correspond to the names in colData(x)$name_sample.}

\item{column_to_test}{indicates the column(s) of the design one wants to test (do not include the intercept).}

\item{P_1}{the number of permutations to use on all gene-cluster combinations.}

\item{P_2}{the number of permutations to use, when a (raw) p-value is < 0.1 (500 by default).}

\item{P_3}{the number of permutations to use, when a (raw) p-value is < 0.01 (2,000 by default).}

\item{P_4}{the number of permutations to use, when a (raw) p-value is < 0.001 (10,000 by default).
In order to obtain a finer ranking for the most significant genes,
if computational resources are available, we encourage users to set P_4 = 20,000.}

\item{N_breaks}{the number of breaks at which to evaluate the comulative density function.}

\item{min_non_zero_cells}{the minimum number of non-zero cells (across all samples) in each cluster for a gene to be evaluated.}

\item{n_cores}{the number of cores to parallelize the tasks on (parallelization is at the cluster level: each cluster is parallelized on a thread).}
}
\value{
A \code{\linkS4class{data.frame}} object.
Columns `gene` and `cluster_id` contain the gene and cell-cluster name, while `p_val`, `p_adj.loc` and `p_adj.glb` report the raw p-values, locally and globally adjusted p-values, via Benjamini and Hochberg (BH) correction.
In locally adjusted p-values (`p_adj.loc`) BH correction is applied in each cluster separately, while in globally adjusted p-values (`p_adj.glb`) BH correction is performed to the results from all clusters.
Column `filtered` indicates whether a gene-cluster result was filtered (if TRUE), or analyzed (if FALSE).
A gene-cluster combination is filtered when fewer than `min_non_zero_cells` non-zero cells are available.
Filtered results have raw and adjusted p-values equal to 1.
}
\description{
\code{distinct_test} tests for differential state between two groups of samples.
}
\examples{
# load the input data:
data("Kang_subset", package = "distinct")
Kang_subset

# create the design of the study:
samples = Kang_subset@metadata$experiment_info$sample_id
group = Kang_subset@metadata$experiment_info$stim
design = model.matrix(~group)
# rownames of the design must indicate sample ids:
rownames(design) = samples
design

# Note that the sample names in `colData(x)$name_sample` have to be the same ones as those in `rownames(design)`.
rownames(design)
unique(SingleCellExperiment::colData(Kang_subset)$sample_id)

# In order to obtain a finer ranking for the most significant genes, if computational resources are available, we encourage users to increase P_4 (i.e., the number of permutations when a raw p-value is < 0.001) and set P_4 = 20,000 (by default P_4 = 10,000).

# The group we would like to test for is in the second column of the design, therefore we will specify: column_to_test = 2

set.seed(61217)
res = distinct_test(
  x = Kang_subset, 
  name_assays_expression = "logcounts",
  name_cluster = "cell",
  design = design,
  column_to_test = 2,
  min_non_zero_cells = 20,
  n_cores = 2)

# We can optionally add the fold change (FC) and log2-FC between groups:
res = log2_FC(res = res,
  x = Kang_subset, 
  name_assays_expression = "cpm",
  name_group = "stim",
  name_cluster = "cell")

# Visualize significant results:
head(top_results(res))

# Visualize significant results from a specified cluster of cells:
top_results(res, cluster = "Dendritic cells")

# By default, results from 'top_results' are sorted by (globally) adjusted p-value;
# they can also be sorted by log2-FC:
top_results(res, cluster = "Dendritic cells", sort_by = "log2FC")

# Visualize significant UP-regulated genes only:
top_results(res, up_down = "UP",
  cluster = "Dendritic cells")

# Plot density and cdf for gene 'ISG15' in cluster 'Dendritic cells'.
plot_densities(x = Kang_subset,
  gene = "ISG15",
  cluster = "Dendritic cells",
  name_assays_expression = "logcounts",
  name_cluster = "cell",
  name_sample = "sample_id",
  name_group = "stim")
 
 plot_cdfs(x = Kang_subset,
   gene = "ISG15",
   cluster = "Dendritic cells",
   name_assays_expression = "logcounts",
   name_cluster = "cell",
   name_sample = "sample_id",
   name_group = "stim")

}
\seealso{
\code{\link{plot_cdfs}}, \code{\link{plot_densities}}, \code{\link{log2_FC}}, \code{\link{top_results}}
}
\author{
Simone Tiberi \email{simone.tiberi@uzh.ch}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_densities.R
\name{plot_densities}
\alias{plot_densities}
\title{Plot sample-specific densities.}
\usage{
plot_densities(
  x,
  name_assays_expression = "logcounts",
  name_cluster = "cluster_id",
  name_sample = "sample_id",
  name_group = "group_id",
  cluster,
  gene,
  group_level = FALSE,
  adjust = 1,
  size = 0.75
)
}
\arguments{
\item{x}{a \code{\linkS4class{SummarizedExperiment}} or a \code{\linkS4class{SingleCellExperiment}} object.}

\item{name_assays_expression}{a character ("logcounts" by default), 
indicating the name of the assays(x) element which stores the expression data (i.e., assays(x)$name_assays_expression).
We strongly encourage using normalized data, such as counts per million (CPM) or log-CPM.}

\item{name_cluster}{a character ("cluster_id" by default), 
indicating the name of the colData(x) element which stores the cluster id of each cell (i.e., colData(x)$name_colData_cluster).}

\item{name_sample}{a character ("sample_id" by default), 
indicating the name of the colData(x) element which stores the sample id of each cell (i.e., colData(x)$name_colData_sample).}

\item{name_group}{a character ("group_id" by default), 
indicating the name of the colData(x) element which stores the group id of each cell (i.e., colData(x)$name_colData_group).}

\item{cluster}{a character, indicating the name of the cluster to plot.}

\item{gene}{a character, indicating the name of the gene to plot.}

\item{group_level}{a logical, indicating whether to plot group-level (if TRUE) or sample-level curves (if FALSE).}

\item{adjust}{a numeric, representing a multiplicate bandwidth adjustment, argument passed to \code{\link{stat_density}}.}

\item{size}{a numeric argument defining the width of lines, passed to \code{\link{stat_density}}.}
}
\value{
A \code{\link{ggplot}} object.
}
\description{
\code{plot_densities} returns a \code{\link{ggplot}} object
with the sample-specific density estimates, for a specified cluster and gene.
}
\examples{
data("Kang_subset", package = "distinct")
Kang_subset

plot_densities(x = Kang_subset,
               gene = "ISG15",
               cluster = "Dendritic cells",
               name_assays_expression = "logcounts",
               name_cluster = "cell",
               name_sample = "sample_id",
               name_group = "stim")

}
\seealso{
\code{\link{distinct_test}}, \code{\link{plot_cdfs}}
}
\author{
Simone Tiberi \email{simone.tiberi@uzh.ch}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_res.R
\name{res}
\alias{res}
\title{Results from \code{\link{distinct_test}} function}
\arguments{
\item{res}{contains a \code{\linkS4class{data.frame}} object,
with the results obtained applying \code{\link{distinct_test}} function to \code{\link{Kang_subset}} dataset.
Below the code used to obtain `res`.}
}
\description{
Results from \code{\link{distinct_test}} function
}
\examples{
# load the input data:
# data("Kang_subset", package = "distinct")
# Kang_subset
# 
# create the design of the study:
# samples = Kang_subset@metadata$experiment_info$sample_id
# group = Kang_subset@metadata$experiment_info$stim
# design = model.matrix(~group)
# rownames of the design must indicate sample ids:
# rownames(design) = samples
# design
# 
# Note that the sample names in `colData(x)$name_sample` have to be the same ones as those in `rownames(design)`.
# rownames(design)
# unique(SingleCellExperiment::colData(Kang_subset)$sample_id)
# 
# In order to obtain a finer ranking for the most significant genes, if computational resources are available, we encourage users to increase P_4 (i.e., the number of permutations when a raw p-value is < 0.001) and set P_4 = 20,000 (by default P_4 = 10,000).
# 
# The group we would like to test for is in the second column of the design, therefore we will specify: column_to_test = 2
# 
# set.seed(61217)
# res = distinct_test(
#   x = Kang_subset, 
#   name_assays_expression = "logcounts",
#   name_cluster = "cell",
#   design = design,
#   column_to_test = 2,
#   min_non_zero_cells = 20,
#   n_cores = 2)
#   
#   save(res, file = "res.RData")
#   saveRDS(res, file = "res.rds")
}
\seealso{
\code{\link{distinct_test}}
}
\author{
Simone Tiberi \email{simone.tiberi@uzh.ch}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_Kang_subset.R
\name{Kang_subset}
\alias{Kang_subset}
\title{Subset from the `Kang18_8vs8()` object of the \code{muscData} package.}
\arguments{
\item{Kang_subset}{contains a \code{\linkS4class{SingleCellExperiment}} object, 
representing a subset of 6 samples (3 individuals observed across 2 conditions) and 100 genes selected from the `Kang18_8vs8()` object of the \code{muscData} package.
Below the code used to subset the original dataset.}
}
\description{
Subset from the `Kang18_8vs8()` object of the \code{muscData} package.
}
\examples{
#################### 
# Object 'Kang_subset' is generated as follows:
####################
# library(muscData)
# sce = Kang18_8vs8()
# 
# library(scater)
# sce = computeLibraryFactors(sce)
# sce = logNormCounts(sce)
# cpm(sce) <- calculateCPM(sce)
# 
# Select genes with at least 1000 non-zero cells:
# sce = sce[ rowSums(assays(sce)$counts > 0) >= 1000, ]
# 
# randomly select 100 of these genes:
# set.seed(61217)
# sel = sample( rownames(sce), size = 100)
# sce = sce[ rownames(sce) \%in\% sel, ]
# 
# select 3 individuals only:
# ind_selected = levels(factor(colData(sce)$ind))[1:3]
# sce = sce[, sce$ind \%in\% ind_selected]
# 
# make a sample_id column:
# colData(sce)$sample_id = factor(paste(colData(sce)$stim, colData(sce)$ind, sep = "_"))
# 
# create an experiment_info object containing sample-group information:
# experiment_info = unique(data.frame(sample_id = colData(sce)$sample_id, 
#                                     stim = colData(sce)$stim) )
# metadata(sce)$experiment_info = data.frame(experiment_info, row.names = NULL)
# 
# remove unnecessary information to reduce storage space:
# sce$cluster = NULL;
# sce$multiplets = NULL;
# rowData(sce) = NULL;
# colnames(sce) = NULL;
# reducedDim(sce) = NULL
# sce$ind = NULL
# sce$sizeFactor = NULL
# rm assays counts
# assays(sce) = assays(sce)[2:3]
#
# Kang_subset = sce
# save(Kang_subset, file = "Kang_subset.RData")
}
\seealso{
\code{\link{distinct_test}}
}
\author{
Simone Tiberi \email{simone.tiberi@uzh.ch}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/top_results.R
\name{top_results}
\alias{top_results}
\title{Filter significant results.}
\usage{
top_results(
  res,
  cluster = "all",
  significance = 0.01,
  global = TRUE,
  up_down = "both",
  sort_by = "p_adj.glb"
)
}
\arguments{
\item{res}{a \code{\linkS4class{data.frame}} with results as returned from \code{\link{distinct_test}}.}

\item{cluster}{a character indicating the cluster(s) whose results have to be returned. 
Results from all clusters are returned by default ("all").}

\item{significance}{numeric, results with adjusted p-value < significance will be returned.}

\item{global}{logical indicating whether to filter results according to p_adj.glb (when TRUE), or p_adj.loc (when FALSE).}

\item{up_down}{a character indicating whether to return: all results ("both" or "BOTH"), only up-regulated results ("up" or "UP") or down-regulated results ("down" or "DOWN").
In `res`, a FC > 1 (or log2FC > 0) indicates up-regulation of group1 (compared to group2); while a FC < 1 (or log2FC < 0) indicates down-regulation of group1 (compared to group2).}

\item{sort_by}{a character indicating how results should be sorted.
Results can be sorted by globally adjusted p-value ("p_adj.glb", default choice), locally adjusted p-value ("p_adj.loc"), raw p-value ("p_val") or (log2)fold-change ("FC" or "log2FC").}
}
\value{
A \code{\linkS4class{data.frame}} object.
Columns `gene` and `cluster_id` contain the gene and cell-cluster name, while `p_val`, `p_adj.loc` and `p_adj.glb` report the raw p-values, locally and globally adjusted p-values, via Benjamini and Hochberg (BH) correction.
In locally adjusted p-values (`p_adj.loc`) BH correction is applied in each cluster separately, while in globally adjusted p-values (`p_adj.glb`) BH correction is performed to the results from all clusters.
}
\description{
\code{top_results} returns the significant results obtained via \code{\link{distinct_test}}.
}
\examples{
# load pre-computed results (obtaines via `distinct_test`)
data("res", package = "distinct")

# Visualize significant results:
head(top_results(res))

# Visualize significant results from a specified cluster of cells:
top_results(res, cluster = "Dendritic cells")

# We can optionally add the fold change (FC) and log2-FC between groups:
# load the input data:
data("Kang_subset", package = "distinct")

res = log2_FC(res = res,
  x = Kang_subset, 
  name_assays_expression = "cpm",
  name_group = "stim",
  name_cluster = "cell")

# By default, results from 'top_results' are sorted by (globally) adjusted p-value;
# they can also be sorted by log2-FC:
top_results(res, cluster = "Dendritic cells", sort_by = "log2FC")

# Visualize significant UP-regulated genes only:
top_results(res, up_down = "UP",
  cluster = "Dendritic cells")

}
\seealso{
\code{\link{distinct_test}}, \code{\link{log2_FC}}
}
\author{
Simone Tiberi \email{simone.tiberi@uzh.ch}
}

\name{distinct-package}
\alias{distinct-package}
\alias{distinct}
\docType{package}
\title{
\packageTitle{distinct}
}
\description{
\packageDescription{distinct}

Questions relative to distinct should be either written to the \href{https://support.bioconductor.org}{Bioconductor support site}, tagging the question with 'distinct', or reported as a new issue at \href{https://github.com/SimoneTiberi/distinct/issues}{BugReports} (preferred choice).

To access the vignettes, type: \code{browseVignettes("distinct")}.
}
\author{
\packageAuthor{distinct}

Maintainer: \packageMaintainer{distinct}
}
\keyword{
  differential distribution,
  differential state,
  differential expression,
  hierarchical permutation tests
}
